#include <stdint.h>
#include <avr/io.h>

#define F_CPU 500000UL
#include <util/delay.h>

#define lcd_port PORTB
#define lcd_dir DDRB
#define lcd_rs_port PORTD
#define lcd_rs_dir DDRD
#define lcd_rs_bit 4
#define lcd_en_port PORTD
#define lcd_en_dir DDRD
#define lcd_en_bit 6

#include "lcd4.inc"

int main(void)
{
	int i, j;

	lcd_setupports();
	lcd_init();

	while(1){
		lcd_string("LCD Display Test");
		lcd_ddram(0x40);
		lcd_string("Version 1.1 2017");
		_delay_ms(1000);
		
		for (i = 0; i < 255; i += 32)
		{
			lcd_ddram(0x00);
			for (j = 0; j < 16; j++){
				lcd_putchar(i+j);
				_delay_ms(200);
			}
			lcd_ddram(0x40);
			for (j = 0; j < 16; j++){
				lcd_putchar(i+j+16);
				_delay_ms(200);
			}
		}
		_delay_ms(200);
		lcd_cls();
		_delay_ms(200);
	}
	return(0);
}